#include <iostream>
#include <functional>
#include <vector>
#include <algorithm>
#include <iterator>
#include <cstdlib>
#include <ctime>
#include "dist_sort.cpp" // ǡºݤΥȴؿɤ߹

typedef int key_type;

// ȤǤι¤
struct val_t
{
        key_type key;
        double data; // ʳΥǡޤȤ
};

inline std::ostream& operator<<(std::ostream& os, const val_t& x)
{
        os << "(" << x.key << ", " << x.data << ")";
        return os;
}

// ¤ val_t ѤΥå
struct get_key_t : public std::unary_function<val_t,key_type>
{
        key_type operator()(const val_t& x) const { return x.key; }
};

int main()
{
        using namespace std;
        static const int N = 10;
        vector<val_t> a(N);

        srand(time(NULL));
        for (int i = 0; i < N; i++) {
                a[i].key = (rand() >> 8) % 10;
                a[i].data = i;
        }
        for (int i = 0; i < N; i++) cout << " " << a[i];
        cout << endl;
        dist_sort<9>(a.begin(), a.end(), get_key_t());
        for (int i = 0; i < N; i++) cout << " " << a[i];
        cout << endl;
        return 0;
}
