#ifndef oln_merge_sort2_cpp
#define oln_merge_sort2_cpp

#include <list>
#include <functional>

template <class T, class C>
void oln_merge_sort2(std::list<T>& a, C cmp)
{
        if (a.empty()) return;
        std::list<T> c;
        std::list<T> b[64];
        std::list<T>* p;
        std::list<T>* pN = &b[0];

        while (!a.empty()) {
                c.splice(c.end(), a, a.begin());
                for (p = &b[0]; !p->empty(); ++p) {
                        p->merge(c, cmp);
                        c.swap(*p);
                }
                c.swap(*p);
                if (p == pN) ++pN;
        }
        for (p = &b[1]; p != pN; ++p) p->merge(*(p - 1), cmp);
        a.swap(*(pN - 1));
}

template <class T>
inline void oln_merge_sort2(std::list<T>& a)
{
        oln_merge_sort2(a, std::less<T>());
}

#endif // oln_merge_sort2_cpp
