/*
  sort-small-bench.cpp - bench mark for various sort at small scale

  Copyright (C) 2010 Taiji Yamada <taiji@aihara.co.jp>

  Distributed under the Boost Software License, Version 1.0. See
  http://www.boost.org/LICENSE_1_0.txt for more details.
*/
#if 0
#define N_ELEMENT 2000
#define N_POINT_DIMENSION 45
#define N_AVERAGE 10
#elif 0
#define N_ELEMENT 50000
#define N_POINT_DIMENSION 223
#define N_AVERAGE 3
#elif 0
#define N_ELEMENT 100000
#define N_POINT_DIMENSION 360
#define N_AVERAGE 3
#else
#define N_ELEMENT 1000000
#define N_POINT_DIMENSION 1000
#define N_AVERAGE 3
#endif
#define DETAIL_BENCH
#define NO_RAPID
//#define WITH_DULLEST
//#define NO_DULL
//#define NO_SORT_VALUES
//#define NO_SORT_INDICE
//#define NO_IN_C
//#define NO_IN_CXX
#include "sort_r-bench.cpp"
